#!/usr/bin/env python
import inspect
from ismatch import ismatch
from public import public


@public
def getmembers(obj, predicate=None, include="*",
               exclude=None, _=True, __=True):
    members = []
    for name, obj in inspect.getmembers(obj, predicate):
        if _ is False and name.find("_") == 0 and name.find("__") != 0:
            continue
        if __ is False and name.find("__") == 0:
            continue
        if include and not ismatch(name, include):
            continue
        if exclude and ismatch(name, exclude):
            continue
        member = (name, obj)
        members.append(member)
    return members
